package crowdmodel.agents;

/**
 * A behaviour rule represents an interaction (or manipulation)
 * with the external world. Implements a body/motor movement.
 * 
 *
 * @author Nanda Wijermans
 *
 */


public class BehaviourRule extends Rule implements Comparable {


	public BehaviourRule(){
//		@Override
	}
	
	/**
	 * Overrides the update activation function of a general
	 * memory element, as I keep track of the behaviours given
	 * their activation level in a treeSet: d_behaviours
	 * This gives rise to a dynamically hierarchy (changeable order)
	 * 
	 * After the activation of a behaviour is updated
	 * By removing from and immediately adding the behaviour to the treeSet
	 * the 
	 */
	public void updateActivation(){
		d_activation = d_baseLevel + d_contextLevel;
		d_thisMemory.updateBehaviourOrdering(this);
	}

//	@Override 
	public int compareTo(Object o) {
		if (o instanceof BehaviourRule){
			BehaviourRule b = (BehaviourRule) o;
			double act2 = b.getActivation();
			double val = act2 - d_activation;
			return (int) Math.rint(val);
		}
		return -1;
	}
	
}
