package crowdmodel.agents;

import java.util.ArrayList;

import crowdmodel.environment.*;
import crowdmodel.utils.*;

/**
 *  A manipulation rule concerns a behaviour that involves
 *  one object changing the other.
 *  <br><br>
 * source: Schweingruber1994, pp13 | McPhail
 * Depending on the object of manipulation and the manipulator
 * itself certain actions are possible: <br>
 * Physical object:
 * <ul>
 * <li> carry/lifting </li>
 * <li> passing </li>
 * <li> striking </li>
 * <li> throwing </li>
 * <li> pushing/pulling </li>
 * <li> other </li>
 * </ul>
 * Person is object:
 * <ul>
 * <li> embracing/clasping </li>
 * <li> restraining </li>
 * <li> carry/dragging </li>
 * <li> striking ? </li>
 * </ul>
 * Person is self:
 * <ul> 
 * <li> clapping </li>
 * <li> snapping </li>
 * </ul>
 * @author Nanda
 */

public class ManipulationRule extends BehaviourRule {

	
	public static final String[] objectManips = {"carry", "lift", "pass", "strike", "throw", "pull", "push", "other"};
	public static final String[] personManips = {"embrace", "restrain", "carry", "strike", "other"};
	public static final String[] selfManips = {"clapping", "snapping"};
	
	private ArrayList<String> objectManipsList;
	private ArrayList<String> personManipsList; 
	private ArrayList<String> selfManipsList;
	
	ManipulationRule() {
		objectManipsList = Misc.fill(objectManips);
		personManipsList = Misc.fill(personManips);
		selfManipsList = Misc.fill(selfManips);
	}
	                
	public void execute(CellObject obj, String manipulation){
	}
	
	
	public void execute(CrowdAgent agent, String manipulation){
	}
	
	public void execute(String manipulation){
		/*
		 * execute for self manipulation
		 */
	}
	
	
	
}
