package crowdmodel.agents;

public class Motor {

	/**
	 * 
	 * Motor is one of the architecture main types.
	 * Architecture consists out of a sensor, motor, memory and physiology part.
	 * All there is to describe behaviour, influences factors, processes, characteristics etc. 
	 * need to be described in either one of the (derived) main parts of the architecture
	 * 
	 * Motor: describes the action/execution of an individual.  
	 * Here the actual execution of a behaviour is processed. This involves that 
	 * the actual changes of the bodily state and world (when applicable) are described.
	 * For instance, when the chosen behaviour is to walk to point A, here it is described
	 * what this means for the new position of the body, but also indicated when something
	 * cannot be executed due to bodily or external physical constraints.
	 * 
	 * @author Nanda Wijermans
	 * 
	 */
	
	protected boolean executeRule(){
	/*
	 * executes a behaviourRule
	 * returns whether the execution failed or not	
	 */
		return true;
	}
}
