package crowdmodel.agents;

/**
 * Rule is a type of memoryElement. 
 * Memory has 3 types of elements: Rules, Facts and Goals
 * A rule defines a manipulation (internally or externally)
 * 
 * 
 * @author Nanda Wijermans
 *
 */

public abstract class Rule extends MemoryElement {

	/**
	 * Function that describes the execution of the given rule.
	 * Returns the success of execution
	 */
	public void execute(){
		//will be overridden by the extended classes (memoryManipulationRule, behaviourRule)
	}
}
