package crowdmodel.styles;

import crowdmodel.environment.CellObject;

import java.awt.Color;
import java.awt.Paint;
import repast.simphony.valueLayer.ValueLayer;
import repast.simphony.visualization.visualization2D.style.ValueLayerStyle;

/**
* Describes the Style for area value layer in 2D display.
* Depending on the type of area, the visualisation differs.
* 
* @author Nanda Wijermans
*/

public class AreaStyle2D implements ValueLayerStyle{

	private static final float CELLSIZE = 15.0f; // 1 cell width ~ 1 pixel on the screen
	
	protected ValueLayer d_layer;
	private Color tan = new Color(205, 133, 63);
	
	public void addValueLayer(ValueLayer layer){
		d_layer = layer;
	}
	
	/**
	 * Returns the Red value of the RGB color depending on the coordinates
	 */
	public int getRed(double... coordinates){
		return 0; 
		}
	
	/**
	 * Returns the Green value of the RGB color depending on the coordinates
	 */
	public int getGreen(double... coordinates){
		return 0;
		}
	
	/**
	 * Returns the Blue value of the RGB color depending on the coordinates
	 */

	public int getBlue(double... coordinates){
		return 0;
	}
	
/**
 * Returns the cell size value	
 * I think this value indicates the link between sim space and the screen
 * 1 cell width ~ 1 pixel on the screen
 */
	public float getCellSize() {
		return CELLSIZE; 
	}

/**
 * Returns the colour based on the value (type of area) at given coordinates.
 */
	public Paint getPaint(double... coordinates){
		double val = d_layer.get(coordinates);
		
		if (val == CellObject.NOOBJECTS) 		// walkable terrain
			return Color.black;
		else if (val == CellObject.POI)
			return Color.white;
		else if (val == CellObject.STAGE) {			// stage area, not walkable
			return Color.yellow;
		}
		else if (val == CellObject.BAR || val == CellObject.TOILET)  // bar/toilet area, not walkable~
			return tan;
		else
			//TODO System.err maken!! 
			return Color.red;
	}			
}
