package crowdmodel.utils;

import java.util.Comparator;

import crowdmodel.agents.BehaviourRule;

/**
 * Describes how to compare two self-defined objects: BehaviourRule.
 * In general one cannot just compare two objects in Java unless they are 
 * primitives (and it is known how to compare them). By implementing the
 * Comparator one specifies the objects that are under comparison and
 * how it should be done.
 * 
 * @author Nanda Wijermans
 *
 */

public class Bcomparator implements Comparator<BehaviourRule> {

	/**
	 * empty constructor
	 */
	public Bcomparator(){	
	}
	
	
	/**
	 * Compares the activation value of two BehaviourRules to design a hierarchical ordering
	 */
	
//	@Override
	public int compare(BehaviourRule b0, BehaviourRule b1) {
		
		double val = b0.getActivation() - b1.getActivation();
		return (int) Math.rint(val);

	}
}
